import numpy as np
import os
import pandas as pd
import torch
import decord
import timeit
import pickle
import json
import random
import cv2
import ffmpeg
import h5py

from PIL import Image
from tqdm import tqdm
from torch.utils.data import Dataset, DataLoader
from torch.autograd.variable import Variable
from torchvision import transforms
from decord import VideoReader, cpu, gpu
from datetime import timedelta
from torch.utils.data.distributed import DistributedSampler
from torch.utils.data._utils.collate import default_collate

# import logging
# logging.basicConfig(filename="error.txt",level=logging.DEBUG)
# logging.captureWarnings(True)


# print('imported!!!')
# os.environ['DECORD_EOF_RETRY_MAX'] = '40960'
decord.bridge.set_bridge('torch')


# test_remove = ['084k_RL3ApU_000109_000119.mp4', '2xWiEVNUvhE_000064_000074.mp4', '305P2f9_lko_004145_004155.mp4',
#                'B4bn9G6__sY_000086_000096.mp4', 'BvBVQmm2RcM_000082_000092.mp4', 'CxjipYE57Yo_000199_000209.mp4',
#                'IhanWvpHGu8_001243_001253.mp4', 'Lw14NH9kAqE_000759_000769.mp4',
#                ' XFkykETgkoo_002967_002977.mp4', 'jJFqy6yiXzQ_000024_000034.mp4',
#                'kinMMqkswUk_000120_000130.mp4', 'y7cYaYX4gdw_000047_000057.mp4']


def multiple_samples_collate(batch):
    """
    Collate function for repeated augmentation. Each instance in the batch has
    more than one sample.
    Args:
        batch (tuple or list): data batch to collate.
    Returns:
        (tuple): collated data batch.
    """
    inputs, labels = zip(*batch)
    inputs = [x for x in inputs if x is not None]
    labels = [x for x in labels if x is not None]

    inputs, labels, = (
        default_collate(inputs),
        default_collate(labels),
    )

    return inputs, labels


class CustomBatchSampler(DistributedSampler):
    r"""Yield a mini-batch of indices. The sampler will drop the last batch of
            an image size bin if it is not equal to ``batch_size``

    Args:
        examples (dict): List from dataset class.
        batch_size (int): Size of mini-batch.
    """

    def __init__(self, data, num_replicas, rank, batch_size, shuffle):
        super().__init__(data, num_replicas, rank, shuffle)
        self.batch_size = batch_size
        self.data = data
        if shuffle:
            random.shuffle(self.data)

    def __iter__(self):
        batch = []
        num_frames = random.choice([4, 8, 16, 32, 64])
        for index, sample in enumerate(self.data):
            batch.append([index, num_frames])

            if len(batch) == self.batch_size:
                yield batch
                num_frames = random.choice([4, 8, 16, 32, 64])
                batch = []

    def __len__(self):
        return len(self.data)


class DivingDL(Dataset):
    def __init__(self, data_split, num_frames, resolution):
        self.num_frames = num_frames
        self.resolution = resolution
        self.root = '/squash/Diving48-zstd/rgb/'
        self.data_split = data_split
        print('resolution: ', resolution)

        train_videos = json.load(open("/squash/Diving48-zstd/Diving48_V2_train.json", 'r'))
        test_videos = json.load(open("/squash/Diving48-zstd/Diving48_V2_test.json", 'r'))
        print(len(train_videos), len(test_videos))

        if data_split == 'train':
            self.data = train_videos

        else:
            self.data = test_videos

        print(len(self.data), self.data[0])

        self.transforms = transforms.Compose([
            transforms.Normalize((0.485, 0.456, 0.406), (0.229, 0.224, 0.225)),
            transforms.Resize([resolution, resolution]),
        ])

    def __len__(self):
        return len(self.data)

    def __getitem__(self, index):
        video, label = self.data[index]['vid_name'],  self.data[index]['label']
        vid_path = os.path.join(self.root + video + '.mp4')

        vr = VideoReader(vid_path)
        frame_indexer = np.linspace(0, len(vr) - 1, self.num_frames)
        frames = vr.get_batch(frame_indexer)
        # print('pre transform: ', frames.shape)
        frames = frames.permute(0, 3, 1, 2) / 255.
        frames = self.transforms(frames).permute(1, 0, 2, 3)
        # print(frames.unique(), frames.shape)

        label = int(label)
        return frames, label


if __name__ == '__main__':
    shuffle = False
    dataloader_gen = DivingDL('train', 2, 224)
    # cb_sampler = CustomBatchSampler(dataloader_gen.data, batch_size=8, num_replicas=1, rank=0, shuffle=True)
    dataloader = DataLoader(dataloader_gen, num_workers=8, batch_size=8, collate_fn=multiple_samples_collate)
    for frames, label in tqdm(dataloader):
        print(frames.shape)
        exit()